<template>
    <div class="uk-flex">
        <div class="uk-margin-small-right">{{ min }}</div>
        <div class="niveau-slider-container uk-margin-small-top">
            <input
                id="range"
                min="-50"
                max="7"
                class="uk-range niveau-slider"
                type="range"
                list="niveaux"
                value="-50"
                @change="changerNiveau()"
            />
            <input
                id="autreRange"
                min="-50"
                max="7"
                value="7"
                class="uk-range niveau-slider"
                type="range"
                list="niveaux2"
                @change="changerNiveau()"
            />
        </div>
        <div class="uk-margin-small-left">{{ max }}</div>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
@Component
export default class FiltreParNiveau extends Vue {
    private min = '50k';
    private max = '8d';

    private changerNiveau() {
        const range = parseInt(
            (document.getElementById('range') as HTMLInputElement).value
        );
        const autreRange = parseInt(
            (document.getElementById('autreRange') as HTMLInputElement).value
        );
        let valMin;
        let valMax;
        if (range < autreRange) {
            valMin = range;
            valMax = autreRange;
        } else {
            valMin = autreRange;
            valMax = range;
        }
        this.min = this.definirAffichage(valMin);
        this.max = this.definirAffichage(valMax);
        this.$emit('setValeursNiveau', valMin, valMax);
    }

    private definirAffichage(intValue: number): string {
        if (intValue < 0) {
            return intValue * -1 + 'k';
        }
        return intValue + 1 + 'd';
    }
}
</script>

<style lang="scss" scoped>
.niveau-slider-container {
    float: none;
    position: relative;
    background: grey;
    height: 3px;
    width: 90%;
}
.niveau-slider {
    position: absolute;
}

@mixin track() {
    background: none; /* get rid of Firefox track background */
    height: 100%;
    width: 100%;
}

@mixin thumb() {
    background: currentcolor;
    border: none; /* get rid of Firefox thumb border */
    border-radius: 0; /* get rid of Firefox corner rounding */
    pointer-events: auto; /* catch clicks */
    width: 12px;
    height: 18px;
}

input[type='range'] {
    &::-webkit-slider-runnable-track,
    &::-webkit-slider-thumb,
    & {
        -webkit-appearance: none;
    }
    background: none; /* get rid of white Chrome background */
    color: #000;
    font: inherit; /* fix too small font-size in both Chrome & Firefox */
    margin: 0;
    pointer-events: none; /* let clicks pass through */

    &::-webkit-slider-runnable-track {
        @include track;
    }
    &::-moz-range-track {
        @include track;
    }

    &::-webkit-slider-thumb {
        @include thumb;
    }
    &::-moz-range-thumb {
        @include thumb;
    }
}
</style>
